## bpp-numcalc-1.8.0.tar.gz

=== CMakeLists.txt ===
# CMake script for Bio++ NumCalc
# Author: Sylvain Gaillard and Julien Dutheil
# Created: 20/08/2009

# Global parameters
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
PROJECT(bpp-numcalc CXX)

IF(NOT CMAKE_BUILD_TYPE)
  SET(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)

SET(CMAKE_CXX_FLAGS "-Wall -Weffc++ -Wshadow")
IF(NOT NO_VIRTUAL_COV)
  SET(NO_VIRTUAL_COV FALSE CACHE BOOL
      "Disable covariant return type with virtual inheritance, for compilers that do not support it."
      FORCE)
ENDIF(NOT NO_VIRTUAL_COV)

IF(NO_VIRTUAL_COV)
  MESSAGE("-- Covariant return with virtual inheritance disabled.")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DNO_VIRTUAL_COV=1")
ENDIF(NO_VIRTUAL_COV)

# Libtool-like version number
# CURRENT:REVISION:AGE => file.so.(C-A).A.R
# current:  The most recent interface number that this library implements.
# revision: The implementation number of the current interface.
# age:      The difference between the newest and oldest interfaces that this
#           library implements.
# In other words, the library implements all the interface numbers in the
# range from number current - age to current.
SET(BPPNUMCALC_VERSION_CURRENT "9")
SET(BPPNUMCALC_VERSION_REVISION "0")
SET(BPPNUMCALC_VERSION_AGE "0")

# Effective version number computation
MATH(EXPR BPPNUMCALC_VERSION_MAJOR "${BPPNUMCALC_VERSION_CURRENT} - ${BPPNUMCALC_VERSION_AGE}")
SET(BPPNUMCALC_VERSION_MINOR ${BPPNUMCALC_VERSION_AGE})
SET(BPPNUMCALC_VERSION_PATCH ${BPPNUMCALC_VERSION_REVISION})
SET(BPPNUMCALC_VERSION "${BPPNUMCALC_VERSION_MAJOR}.${BPPNUMCALC_VERSION_MINOR}.${BPPNUMCALC_VERSION_PATCH}")

# Set the CMAKE_PREFIX_PATH for the find_library fonction when using non
# standard install location
IF(CMAKE_INSTALL_PREFIX)
  SET(CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}" ${CMAKE_PREFIX_PATH})
ENDIF(CMAKE_INSTALL_PREFIX)

#here is a useful function:
MACRO(IMPROVED_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
  #start:
  FIND_PATH(${lib_name}_INCLUDE_DIR ${include_to_find})
  SET(${lib_name}_NAMES ${lib_name} ${lib_name}lib ${lib_name}dll)
  FIND_LIBRARY(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES})

  IF(${lib_name}_LIBRARY)
    MESSAGE("-- Library ${lib_name} found here:")
    MESSAGE("   includes : ${${lib_name}_INCLUDE_DIR}")
    MESSAGE("   libraries: ${${lib_name}_LIBRARY}")
  ELSE(${lib_name}_LIBRARY)
    MESSAGE(FATAL_ERROR "${lib_name} required but not found.")
  ENDIF(${lib_name}_LIBRARY)
  
  #add the dependency:
  INCLUDE_DIRECTORIES(${${lib_name}_INCLUDE_DIR})
  SET(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_LIBRARY})
ENDMACRO(IMPROVED_FIND_LIBRARY)

#Find the Bio++ libraries:
IMPROVED_FIND_LIBRARY(LIBS bpp-utils Utils/Clonable.h)

# Subdirectories
ADD_SUBDIRECTORY(NumCalc)

# Doxygen
FIND_PACKAGE(Doxygen)
IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET (apidoc ${DOXYGEN_EXECUTABLE} Doxyfile)
ENDIF (DOXYGEN_FOUND)

# Packager
SET(CPACK_PACKAGE_NAME "libbpp-numcalc")
SET(CPACK_PACKAGE_VENDOR "Bio++ Development Team")
SET(CPACK_PACKAGE_VERSION "1.8.0")
SET(CPACK_PACKAGE_VERSION_MAJOR "1")
SET(CPACK_PACKAGE_VERSION_MINOR "8")
SET(CPACK_PACKAGE_VERSION_PATCH "0")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "The Bio++ NumCalc library")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/COPYING")
SET(CPACK_RESOURCE_FILE_AUTHORS "${CMAKE_SOURCE_DIR}/AUTHORS")
SET(CPACK_SOURCE_GENERATOR "TGZ")
SET(CPACK_SOURCE_IGNORE_FILES
 "CMakeFiles"
 "Makefile"
 "_CPack_Packages"
 "CMakeCache.txt"
 ".*\\\\.cmake"
 "/CVS/"
 ".*\\\\.gz"
 ".*\\\\.deb"
 ".*\\\\.rpm"
 "\\\\..*\\\\.swp"
 "NumCalc/\\\\..*"
 "NumCalc/libbpp*"
 "debian/libbpp*"
 "debian/tmp"
 "html"
 "NumCalc.tag"
 ${CPACK_SOURCE_IGNORE_FILES}
)
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
INCLUDE(CPack)

#This adds the 'dist' target
ADD_CUSTOM_TARGET(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

IF (UNIX)
#This creates deb packages:
ADD_CUSTOM_TARGET(deb fakeroot debian/rules binary)
ADD_DEPENDENCIES(deb dist)

#This creates rpm packages:
ADD_CUSTOM_TARGET(rpm rpmbuild -ta ${CPACK_SOURCE_PACKAGE_FILE_NAME}.tar.gz)
ADD_DEPENDENCIES(rpm dist)

ENDIF()

=== NumCalc/CMakeLists.txt ===
# CMake script for Bio++ NumCalc
# Author: Sylvain Gaillard
# Created: 20/08/2009

# File list
SET(CPP_FILES
  AbstractDiscreteDistribution.cpp
  AbstractOptimizer.cpp
  AbstractParameterAliasable.cpp
  AbstractParametrizable.cpp
  AutoParameter.cpp
  BrentOneDimension.cpp
  ConjugateGradientMultiDimensions.cpp
  ConstantDistribution.cpp
  DataTable.cpp
  DirectionFunction.cpp
  Domain.cpp
  DownhillSimplexMethod.cpp
  ExponentialDiscreteDistribution.cpp
  TruncatedExponentialDiscreteDistribution.cpp
  FivePointsNumericalDerivative.cpp
  FunctionTools.cpp
  GammaDiscreteDistribution.cpp
  GoldenSectionSearch.cpp
  IntervalData.cpp
  InvariantMixedDiscreteDistribution.cpp
  MetaOptimizer.cpp
  NewtonOneDimension.cpp
  NumCalcApplicationTools.cpp
  NumConstants.cpp
  NumTools.cpp
  OneDimensionOptimizationTools.cpp
  OptimizationStopCondition.cpp
  Parameter.cpp
  ParameterExceptions.cpp
  ParameterList.cpp
  PowellMultiDimensions.cpp
  RandomTools.cpp
  ReparametrizationFunctionWrapper.cpp
  SimpleDiscreteDistribution.cpp
  SimpleMultiDimensions.cpp
  SimpleNewtonMultiDimensions.cpp
  TestUnit.cpp
  ThreePointsNumericalDerivative.cpp
  TwoPointsNumericalDerivative.cpp
  Uniform01K.cpp
  Uniform01QD.cpp
  Uniform01WH.cpp
  VectorTools.cpp
  RescaledHmmLikelihood.cpp
  LogsumHmmLikelihood.cpp
  LowMemoryRescaledHmmLikelihood.cpp
  AdaptiveKernelDensityEstimation.cpp
  )

SET(H_FILES
  AbstractDiscreteDistribution.h
  AbstractNumericalDerivative.h
  AbstractOptimizer.h
  AbstractParameterAliasable.h
  AbstractParametrizable.h
  AutoParameter.h
  BrentOneDimension.h
  ConjugateGradientMultiDimensions.h
  ConstantDistribution.h
  Constraints.h
  DataTable.h
  DataTableExceptions.h
  DirectionFunction.h
  DiscreteDistribution.h
  Domain.h
  DownhillSimplexMethod.h
  EigenValue.h
  ExponentialDiscreteDistribution.h
  TruncatedExponentialDiscreteDistribution.h
  FivePointsNumericalDerivative.h
  FunctionTools.h
  Functions.h
  GammaDiscreteDistribution.h
  GoldenSectionSearch.h
  IntervalData.h
  InvariantMixedDiscreteDistribution.h
  LUDecomposition.h
  Matrix.h
  MatrixTools.h
  MetaOptimizer.h
  NewtonOneDimension.h
  NumCalcApplicationTools.h
  NumConstants.h
  NumTools.h
  OneDimensionOptimizationTools.h
  OptimizationStopCondition.h
  Optimizer.h
  Parameter.h
  ParameterAliasable.h
  ParameterExceptions.h
  ParameterList.h
  Parametrizable.h
  PowellMultiDimensions.h
  RandomFactory.h
  RandomTools.h
  ReparametrizationFunctionWrapper.h
  SimpleDiscreteDistribution.h
  SimpleMultiDimensions.h
  SimpleNewtonMultiDimensions.h
  StatTest.h
  TestUnit.h
  ThreePointsNumericalDerivative.h
  TransformedParameter.h
  TwoPointsNumericalDerivative.h
  Uniform01K.h
  Uniform01QD.h
  Uniform01WH.h
  VectorExceptions.h
  VectorTools.h
  HmmExceptions.h
  HmmStateAlphabet.h
  HmmTransitionMatrix.h
  HmmEmissionProbabilities.h
  HmmLikelihood.h
  RescaledHmmLikelihood.h
  LogsumHmmLikelihood.h
  LowMemoryRescaledHmmLikelihood.h
  AdaptiveKernelDensityEstimation.h
  distributions
  functions
  matrix
  optimizers
  parameters
  random
  vectors
  )

# Build the static lib
ADD_LIBRARY(bppnumcalc-static STATIC ${CPP_FILES})
SET_TARGET_PROPERTIES(bppnumcalc-static
  PROPERTIES OUTPUT_NAME bpp-numcalc
  CLEAN_DIRECT_OUTPUT 1
  )
TARGET_LINK_LIBRARIES(bppnumcalc-static ${LIBS})

# Build the shared lib
ADD_LIBRARY(bppnumcalc-shared SHARED ${CPP_FILES})
SET_TARGET_PROPERTIES(bppnumcalc-shared
  PROPERTIES OUTPUT_NAME bpp-numcalc
  CLEAN_DIRECT_OUTPUT 1
  VERSION ${BPPNUMCALC_VERSION}
  SOVERSION ${BPPNUMCALC_VERSION_MAJOR}
  )
TARGET_LINK_LIBRARIES(bppnumcalc-shared ${LIBS})

# Install libs
INSTALL(TARGETS bppnumcalc-static bppnumcalc-shared DESTINATION lib)

# Install headers
INSTALL(FILES ${H_FILES} DESTINATION include/NumCalc)

=== debian/changelog ===
libbpp-numcalc (1.8.0) unstable; urgency=low

  * Tools for hidden Markov models.
  * Improved gestion of parameter transformations.
  * New LinearMatrix class.
  * Compilation with -Weffc++

 -- Julien Dutheil <jdutheil@birc.au.dk>  Wed, 24 Mar 2010 16:18:52 +0100

libbpp-numcalc (1.7.0) unstable; urgency=low

  * Several interface changes, to allow namespace in parameter names +
  aliasing functions.
  * Several bug fixed + new vector and matrix tools.

 -- Julien Dutheil <jdutheil@birc.au.dk>  Wed, 10 Jun 2009 11:28:58 +0100

libbpp-numcalc (1.6.0) unstable; urgency=low

  * New numerical cross derivatives + new methods in RandomTools &
  VectorTools.

 -- Julien Dutheil <jdutheil@birc.au.dk>  Thu, 11 Dec 2008 12:21:37 +0100

libbpp-numcalc (1.5.0) unstable; urgency=low

  * Initial Release.

 -- Julien Dutheil <jdutheil@birc.au.dk>  Mon, 21 Jul 2008 15:17:26 +0200

=== debian/control ===
Source: libbpp-numcalc
Section: libs
Priority: optional
Maintainer: Julien Dutheil <julien.dutheil@univ-montp2.fr>
Build-Depends: debhelper (>= 5), cmake (>= 2.6)
Standards-Version: 3.7.2

Package: libbpp-numcalc-dev
Section: libdevel
Architecture: any
Depends: libbpp-numcalc (= ${source:Version}), libbpp-utils-dev (>= 1.5.0)
Description: The Bio++ NumCalc library development files.
 Contains the Bio++ classes for numerical calculus.

Package: libbpp-numcalc
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libbpp-utils (>= 1.5.0)
Description: The Bio++ NumCalc library.
 Contains the Bio++ classes for numerical calculus.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# 24/01/10 Modification for use with CMake by Julien Dutheil.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# shared library versions
version=`ls NumCalc/.libs/lib*.so.* | \
 awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
major=`ls NumCalc/.libs/lib*.so.* | \
 awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

configure:
	cmake -DCMAKE_INSTALL_PREFIX=/usr .

config.status: configure
	dh_testdir

build: build-stamp
build-stamp:  config.status
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE)

	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp 

	# Add here commands to clean up after the build process.
	[ ! -f Makefile ] || $(MAKE) clean

	dh_clean 

install: build
	dh_testdir
	dh_testroot
	dh_clean -k 
	dh_installdirs

	# Add here commands to install the package into debian/tmp
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install


# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installexamples
#	dh_install
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
#	dh_python
#	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	#have to do that, otherwise nothing is installed!
	cp -r $(CURDIR)/debian/tmp/usr/lib/lib*.so* $(CURDIR)/debian/libbpp-numcalc/usr/lib
	cp -r $(CURDIR)/debian/tmp/usr/lib/lib*.*a $(CURDIR)/debian/libbpp-numcalc-dev/usr/lib
	cp -r $(CURDIR)/debian/tmp/usr/include/* $(CURDIR)/debian/libbpp-numcalc-dev/usr/include
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
